package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.MarketAimPlace;
import com.izouma.awesomeadmin.service.MarketAimPlaceService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/marketAimPlace")
public class MarketAimPlaceController {

    @Autowired
    private MarketAimPlaceService marketAimPlaceService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(MarketAimPlace record) {
        List<MarketAimPlace> pp = marketAimPlaceService.getMarketAimPlaceList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getMarketAimPlace", method = RequestMethod.GET)
    @ResponseBody
    public Result getMarketAimPlace(@RequestParam(required = false, value = "id") String id) {
        MarketAimPlace data = marketAimPlaceService.getMarketAimPlaceById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(MarketAimPlace record) {
        MarketAimPlace data = marketAimPlaceService.getMarketAimPlace(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, MarketAimPlace record) {
        Map<String, Object> result = new HashMap<>();

        List<MarketAimPlace> pp =marketAimPlaceService.getMarketAimPlaceByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(MarketAimPlace record) {
        boolean num = marketAimPlaceService.createMarketAimPlace(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateMarketAimPlace(MarketAimPlace record) {
        boolean num = marketAimPlaceService.updateMarketAimPlace(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteMarketAimPlace(MarketAimPlace record) {

        boolean num = marketAimPlaceService.deleteMarketAimPlace(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, MarketAimPlace record) throws Exception {

    List<MarketAimPlace> marketAimPlaces = marketAimPlaceService.getMarketAimPlaceList(record);


        String sheetName = "market_aim_place";
        String titleName = "目的地信息表数据表";
        String fileName = "目的地信息表表";
        int columnNumber = 13;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "编号" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "策划备注" ,   "编号" ,   "名称" ,   "x" ,   "y" ,   "z" ,   "类别"  };
        String[][] dataList = new String[marketAimPlaces.size()][13];

        for (int i = 0; i < marketAimPlaces.size(); i++) {

                        dataList[i][0] = String.valueOf(marketAimPlaces.get(i).getId());
                        dataList[i][1] = String.valueOf(marketAimPlaces.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(marketAimPlaces.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(marketAimPlaces.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(marketAimPlaces.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(marketAimPlaces.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(marketAimPlaces.get(i).getRemark());
                        dataList[i][7] = String.valueOf(marketAimPlaces.get(i).getMarketId());
                        dataList[i][8] = String.valueOf(marketAimPlaces.get(i).getPlaceName());
                        dataList[i][9] = String.valueOf(marketAimPlaces.get(i).getPosX());
                        dataList[i][10] = String.valueOf(marketAimPlaces.get(i).getPosY());
                        dataList[i][11] = String.valueOf(marketAimPlaces.get(i).getPosZ());
                        dataList[i][12] = String.valueOf(marketAimPlaces.get(i).getType());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

